diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-routing.cc ns-3.40/src/dsr/model/dsr-routing.cc
--- ns-3.39/src/dsr/model/dsr-routing.cc	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-routing.cc	2023-09-27 13:30:37.642839000 -0700
@@ -443,8 +443,7 @@
                                               << m_maxNetworkDelay.As(Time::S));
         Ptr<dsr::DsrNetworkQueue> queue_i =
             CreateObject<dsr::DsrNetworkQueue>(m_maxNetworkSize, m_maxNetworkDelay);
-        std::pair<std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator, bool> result_i =
-            m_priorityQueue.insert(std::make_pair(i, queue_i));
+        auto result_i = m_priorityQueue.insert(std::make_pair(i, queue_i));
         NS_ASSERT_MSG(result_i.second, "Error in creating queues");
     }
     Ptr<dsr::DsrRreqTable> rreqTable = CreateObject<dsr::DsrRreqTable>();
@@ -748,7 +747,7 @@
     else
     {
         NS_LOG_DEBUG("Print all the elements in a vector");
-        for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
+        for (auto i = vec.begin(); i != vec.end(); ++i)
         {
             NS_LOG_DEBUG("The ip address " << *i);
         }
@@ -774,7 +773,7 @@
                                                                  << vec.back());
         return ipv4Address;
     }
-    for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
+    for (auto i = vec.begin(); i != vec.end(); ++i)
     {
         if (ipv4Address == (*i))
         {
@@ -866,8 +865,7 @@
     NS_LOG_INFO(Simulator::Now().As(Time::S) << " Checking send buffer at " << m_mainAddress
                                              << " with size " << m_sendBuffer.GetSize());
 
-    for (std::vector<DsrSendBuffEntry>::iterator i = m_sendBuffer.GetBuffer().begin();
-         i != m_sendBuffer.GetBuffer().end();)
+    for (auto i = m_sendBuffer.GetBuffer().begin(); i != m_sendBuffer.GetBuffer().end();)
     {
         NS_LOG_DEBUG("Here we try to find the data packet in the send buffer");
         Ipv4Address destination = i->GetDestination();
@@ -895,7 +893,7 @@
              * Peek data to get the option type as well as length and segmentsLeft field
              */
             uint32_t size = copyP->GetSize();
-            uint8_t* data = new uint8_t[size];
+            auto data = new uint8_t[size];
             copyP->CopyData(data, size);
 
             uint8_t optionType = 0;
@@ -959,8 +957,7 @@
                     m_ipv4Route->SetOutputDevice(dev);
 
                     uint32_t priority = GetPriority(DSR_CONTROL_PACKET); /// This will be priority 0
-                    std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator i =
-                        m_priorityQueue.find(priority);
+                    auto i = m_priorityQueue.find(priority);
                     Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = i->second;
                     NS_LOG_LOGIC("Will be inserting into priority queue number: " << priority);
 
@@ -1175,7 +1172,7 @@
          * Peek data to get the option type as well as length and segmentsLeft field
          */
         uint32_t size = pktMinusIpHdr->GetSize();
-        uint8_t* data = new uint8_t[size];
+        auto data = new uint8_t[size];
         pktMinusIpHdr->CopyData(data, size);
         uint8_t optionType = 0;
         optionType = *(data);
@@ -1451,7 +1448,7 @@
                                                                << newPacket->GetSize());
 
         uint32_t priority = GetPriority(DSR_CONTROL_PACKET);
-        std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator i = m_priorityQueue.find(priority);
+        auto i = m_priorityQueue.find(priority);
         Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = i->second;
         NS_LOG_DEBUG("Will be inserting into priority queue " << dsrNetworkQueue
                                                               << " number: " << priority);
@@ -1501,7 +1498,7 @@
     route->SetOutputDevice(dev);
 
     uint32_t priority = GetPriority(DSR_CONTROL_PACKET);
-    std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator i = m_priorityQueue.find(priority);
+    auto i = m_priorityQueue.find(priority);
     Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = i->second;
     NS_LOG_DEBUG("Will be inserting into priority queue " << dsrNetworkQueue
                                                           << " number: " << priority);
@@ -1740,7 +1737,7 @@
     m_ipv4Route->SetOutputDevice(dev);
 
     uint32_t priority = GetPriority(DSR_DATA_PACKET);
-    std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator i = m_priorityQueue.find(priority);
+    auto i = m_priorityQueue.find(priority);
     Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = i->second;
     NS_LOG_INFO("Will be inserting into priority queue number: " << priority);
 
@@ -1782,7 +1779,7 @@
     // priorities ranging from 0 to m_numPriorityQueues, with 0 as the highest priority
     for (uint32_t i = priority; numPriorities < m_numPriorityQueues; numPriorities++)
     {
-        std::map<uint32_t, Ptr<DsrNetworkQueue>>::iterator q = m_priorityQueue.find(i);
+        auto q = m_priorityQueue.find(i);
         Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = q->second;
         uint32_t queueSize = dsrNetworkQueue->GetSize();
         if (queueSize == 0)
@@ -1799,10 +1796,7 @@
         else
         {
             uint32_t totalQueueSize = 0;
-            for (std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator j =
-                     m_priorityQueue.begin();
-                 j != m_priorityQueue.end();
-                 j++)
+            for (auto j = m_priorityQueue.begin(); j != m_priorityQueue.end(); j++)
             {
                 NS_LOG_INFO("The size of the network queue for " << j->first << " is "
                                                                  << j->second->GetSize());
@@ -1854,18 +1848,14 @@
     // We may want to get the queue first and then we need to save a vector of the entries here and
     // then find
     uint32_t priority = GetPriority(DSR_DATA_PACKET);
-    std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator i = m_priorityQueue.find(priority);
+    auto i = m_priorityQueue.find(priority);
     Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = i->second;
 
     std::vector<DsrNetworkQueueEntry> newNetworkQueue = dsrNetworkQueue->GetQueue();
-    for (std::vector<DsrNetworkQueueEntry>::iterator i = newNetworkQueue.begin();
-         i != newNetworkQueue.end();
-         i++)
+    for (auto i = newNetworkQueue.begin(); i != newNetworkQueue.end(); i++)
     {
         Ipv4Address nextHop = i->GetNextHopAddress();
-        for (std::map<NetworkKey, Timer>::iterator j = m_addressForwardTimer.begin();
-             j != m_addressForwardTimer.end();
-             j++)
+        for (auto j = m_addressForwardTimer.begin(); j != m_addressForwardTimer.end(); j++)
         {
             if (nextHop == j->first.m_nextHop)
             {
@@ -2031,7 +2021,7 @@
              * Peek data to get the option type as well as length and segmentsLeft field
              */
             uint32_t size = copyP->GetSize();
-            uint8_t* data = new uint8_t[size];
+            auto data = new uint8_t[size];
             copyP->CopyData(data, size);
 
             uint8_t optionType = 0;
@@ -2085,8 +2075,7 @@
                     m_ipv4Route->SetOutputDevice(dev);
 
                     uint32_t priority = GetPriority(DSR_CONTROL_PACKET);
-                    std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator i =
-                        m_priorityQueue.find(priority);
+                    auto i = m_priorityQueue.find(priority);
                     Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = i->second;
                     NS_LOG_DEBUG("Will be inserting into priority queue "
                                  << dsrNetworkQueue << " number: " << priority);
@@ -2259,7 +2248,7 @@
     // TODO if find the linkkey, we need to remove it
 
     // Find the network acknowledgment timer
-    std::map<LinkKey, Timer>::const_iterator i = m_linkAckTimer.find(linkKey);
+    auto i = m_linkAckTimer.find(linkKey);
     if (i == m_linkAckTimer.end())
     {
         NS_LOG_INFO("did not find the link timer");
@@ -2308,7 +2297,7 @@
                          << mb.GetNextHop() << " source " << mb.GetSrc() << " destination "
                          << mb.GetDst() << " segsLeft " << (uint32_t)mb.GetSegsLeft());
     // Find the network acknowledgment timer
-    std::map<NetworkKey, Timer>::const_iterator i = m_addressForwardTimer.find(networkKey);
+    auto i = m_addressForwardTimer.find(networkKey);
     if (i == m_addressForwardTimer.end())
     {
         NS_LOG_INFO("did not find the packet timer");
@@ -2349,7 +2338,7 @@
     m_passiveCnt.erase(passiveKey);
 
     // Find the passive acknowledgment timer
-    std::map<PassiveKey, Timer>::const_iterator j = m_passiveAckTimer.find(passiveKey);
+    auto j = m_passiveAckTimer.find(passiveKey);
     if (j == m_passiveAckTimer.end())
     {
         NS_LOG_INFO("did not find the passive timer");
@@ -2523,7 +2512,7 @@
 
         // Send out the data packet
         uint32_t priority = GetPriority(DSR_DATA_PACKET);
-        std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator i = m_priorityQueue.find(priority);
+        auto i = m_priorityQueue.find(priority);
         Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = i->second;
         NS_LOG_DEBUG("Will be inserting into priority queue " << dsrNetworkQueue
                                                               << " number: " << priority);
@@ -3309,7 +3298,7 @@
      * The destination address here is directed broadcast address
      */
     uint32_t priority = GetPriority(DSR_CONTROL_PACKET);
-    std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator i = m_priorityQueue.find(priority);
+    auto i = m_priorityQueue.find(priority);
     Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = i->second;
     NS_LOG_LOGIC("Inserting into priority queue number: " << priority);
 
@@ -3363,16 +3352,14 @@
         /**
          * Push back the node addresses other than those between srcAddress and our own ip address
          */
-        std::vector<Ipv4Address>::iterator before =
-            find(nodeList.begin(), nodeList.end(), srcAddress);
-        for (std::vector<Ipv4Address>::iterator i = nodeList.begin(); i != before; ++i)
+        auto before = find(nodeList.begin(), nodeList.end(), srcAddress);
+        for (auto i = nodeList.begin(); i != before; ++i)
         {
             m_finalRoute.push_back(*i);
         }
         m_finalRoute.push_back(srcAddress);
-        std::vector<Ipv4Address>::iterator after =
-            find(nodeList.begin(), nodeList.end(), m_mainAddress);
-        for (std::vector<Ipv4Address>::iterator j = after; j != nodeList.end(); ++j)
+        auto after = find(nodeList.begin(), nodeList.end(), m_mainAddress);
+        for (auto j = after; j != nodeList.end(); ++j)
         {
             m_finalRoute.push_back(*j);
         }
@@ -3426,7 +3413,7 @@
     NS_LOG_INFO("The output device " << dev << " packet is: " << *packet);
 
     uint32_t priority = GetPriority(DSR_CONTROL_PACKET);
-    std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator i = m_priorityQueue.find(priority);
+    auto i = m_priorityQueue.find(priority);
     Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = i->second;
     NS_LOG_INFO("Inserting into priority queue number: " << priority);
 
@@ -3509,7 +3496,7 @@
     route->SetOutputDevice(dev);
 
     uint32_t priority = GetPriority(DSR_CONTROL_PACKET);
-    std::map<uint32_t, Ptr<dsr::DsrNetworkQueue>>::iterator i = m_priorityQueue.find(priority);
+    auto i = m_priorityQueue.find(priority);
     Ptr<dsr::DsrNetworkQueue> dsrNetworkQueue = i->second;
 
     NS_LOG_LOGIC("Will be inserting into priority queue " << dsrNetworkQueue
@@ -3568,7 +3555,7 @@
      * Peek data to get the option type as well as length and segmentsLeft field
      */
     uint32_t size = p->GetSize();
-    uint8_t* data = new uint8_t[size];
+    auto data = new uint8_t[size];
     p->CopyData(data, size);
 
     uint8_t optionType = 0;
@@ -3770,7 +3757,7 @@
 Ptr<dsr::DsrOptions>
 DsrRouting::GetOption(int optionNumber)
 {
-    for (DsrOptionList_t::iterator i = m_options.begin(); i != m_options.end(); ++i)
+    for (auto i = m_options.begin(); i != m_options.end(); ++i)
     {
         if ((*i)->GetOptionNumber() == optionNumber)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-rreq-table.cc ns-3.40/src/dsr/model/dsr-rreq-table.cc
--- ns-3.39/src/dsr/model/dsr-rreq-table.cc	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-rreq-table.cc	2023-09-27 13:30:37.642839000 -0700
@@ -71,9 +71,7 @@
     NS_LOG_FUNCTION(this);
     Ipv4Address firstExpire;
     Time max = Seconds(0.0);
-    for (std::map<Ipv4Address, RreqTableEntry>::const_iterator i = m_rreqDstMap.begin();
-         i != m_rreqDstMap.end();
-         ++i)
+    for (auto i = m_rreqDstMap.begin(); i != m_rreqDstMap.end(); ++i)
     {
         Ipv4Address dst = i->first;
         RreqTableEntry rreqTableEntry = i->second;
@@ -90,7 +88,7 @@
 DsrRreqTable::FindAndUpdate(Ipv4Address dst)
 {
     NS_LOG_FUNCTION(this << dst);
-    std::map<Ipv4Address, RreqTableEntry>::const_iterator i = m_rreqDstMap.find(dst);
+    auto i = m_rreqDstMap.find(dst);
     if (i == m_rreqDstMap.end())
     {
         NS_LOG_LOGIC("The request table entry for " << dst << " not found");
@@ -123,7 +121,7 @@
 DsrRreqTable::RemoveRreqEntry(Ipv4Address dst)
 {
     NS_LOG_FUNCTION(this << dst);
-    std::map<Ipv4Address, RreqTableEntry>::const_iterator i = m_rreqDstMap.find(dst);
+    auto i = m_rreqDstMap.find(dst);
     if (i == m_rreqDstMap.end())
     {
         NS_LOG_LOGIC("The request table entry not found");
@@ -139,7 +137,7 @@
 DsrRreqTable::GetRreqCnt(Ipv4Address dst)
 {
     NS_LOG_FUNCTION(this << dst);
-    std::map<Ipv4Address, RreqTableEntry>::const_iterator i = m_rreqDstMap.find(dst);
+    auto i = m_rreqDstMap.find(dst);
     if (i == m_rreqDstMap.end())
     {
         NS_LOG_LOGIC("Request table entry not found");
@@ -159,7 +157,7 @@
 DsrRreqTable::CheckUniqueRreqId(Ipv4Address dst)
 {
     NS_LOG_LOGIC("The size of id cache " << m_rreqIdCache.size());
-    std::map<Ipv4Address, uint32_t>::const_iterator i = m_rreqIdCache.find(dst);
+    auto i = m_rreqIdCache.find(dst);
     if (i == m_rreqIdCache.end())
     {
         NS_LOG_LOGIC("No Request id for " << dst << " found, initialize it to 0");
@@ -210,7 +208,7 @@
 DsrRreqTable::FindUnidirectional(Ipv4Address neighbor)
 {
     PurgeNeighbor(); // purge the neighbor cache
-    for (std::vector<BlackList>::iterator i = m_blackList.begin(); i != m_blackList.end(); ++i)
+    for (auto i = m_blackList.begin(); i != m_blackList.end(); ++i)
     {
         if (i->m_neighborAddress == neighbor)
         {
@@ -224,7 +222,7 @@
 DsrRreqTable::MarkLinkAsUnidirectional(Ipv4Address neighbor, Time blacklistTimeout)
 {
     NS_LOG_LOGIC("Add neighbor address in blacklist " << m_blackList.size());
-    for (std::vector<BlackList>::iterator i = m_blackList.begin(); i != m_blackList.end(); i++)
+    for (auto i = m_blackList.begin(); i != m_blackList.end(); i++)
     {
         if (i->m_neighborAddress == neighbor)
         {
@@ -260,8 +258,7 @@
     /*
      * this function will return false if the entry is not found, true if duplicate entry find
      */
-    std::map<Ipv4Address, std::list<DsrReceivedRreqEntry>>::const_iterator i =
-        m_sourceRreqMap.find(src);
+    auto i = m_sourceRreqMap.find(src);
     if (i == m_sourceRreqMap.end())
     {
         NS_LOG_LOGIC("The source request table entry for " << src << " not found");
@@ -284,9 +281,7 @@
     }
 
     // We loop the receive rreq entry to find duplicate
-    for (std::list<DsrReceivedRreqEntry>::const_iterator j = receivedRreqEntryList.begin();
-         j != receivedRreqEntryList.end();
-         ++j)
+    for (auto j = receivedRreqEntryList.begin(); j != receivedRreqEntryList.end(); ++j)
     {
         if (*j == rreqEntry) /// Check if we have found one duplication entry or not
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-rsendbuff.cc ns-3.40/src/dsr/model/dsr-rsendbuff.cc
--- ns-3.39/src/dsr/model/dsr-rsendbuff.cc	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-rsendbuff.cc	2023-09-27 13:30:37.642839000 -0700
@@ -56,9 +56,7 @@
 DsrSendBuffer::Enqueue(DsrSendBuffEntry& entry)
 {
     Purge();
-    for (std::vector<DsrSendBuffEntry>::const_iterator i = m_sendBuffer.begin();
-         i != m_sendBuffer.end();
-         ++i)
+    for (auto i = m_sendBuffer.begin(); i != m_sendBuffer.end(); ++i)
     {
         //      NS_LOG_DEBUG ("packet id " << i->GetPacket ()->GetUid () << " " << entry.GetPacket
         //      ()->GetUid ()
@@ -94,8 +92,7 @@
     /*
      * Drop the packet with destination address dst
      */
-    for (std::vector<DsrSendBuffEntry>::iterator i = m_sendBuffer.begin(); i != m_sendBuffer.end();
-         ++i)
+    for (auto i = m_sendBuffer.begin(); i != m_sendBuffer.end(); ++i)
     {
         if (i->GetDestination() == dst)
         {
@@ -116,8 +113,7 @@
     /*
      * Dequeue the entry with destination address dst
      */
-    for (std::vector<DsrSendBuffEntry>::iterator i = m_sendBuffer.begin(); i != m_sendBuffer.end();
-         ++i)
+    for (auto i = m_sendBuffer.begin(); i != m_sendBuffer.end(); ++i)
     {
         if (i->GetDestination() == dst)
         {
@@ -136,9 +132,7 @@
     /*
      * Make sure if the send buffer contains entry with certain dst
      */
-    for (std::vector<DsrSendBuffEntry>::const_iterator i = m_sendBuffer.begin();
-         i != m_sendBuffer.end();
-         ++i)
+    for (auto i = m_sendBuffer.begin(); i != m_sendBuffer.end(); ++i)
     {
         if (i->GetDestination() == dst)
         {
@@ -171,8 +165,7 @@
      */
     NS_LOG_INFO("The send buffer size " << m_sendBuffer.size());
     IsExpired pred;
-    for (std::vector<DsrSendBuffEntry>::iterator i = m_sendBuffer.begin(); i != m_sendBuffer.end();
-         ++i)
+    for (auto i = m_sendBuffer.begin(); i != m_sendBuffer.end(); ++i)
     {
         if (pred(*i))
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/test/dsr-test-suite.cc ns-3.40/src/dsr/test/dsr-test-suite.cc
--- ns-3.39/src/dsr/test/dsr-test-suite.cc	2023-07-05 14:23:47.785427300 -0700
+++ ns-3.40/src/dsr/test/dsr-test-suite.cc	2023-09-27 13:30:37.642839000 -0700
@@ -443,7 +443,7 @@
         Ipv4Address("0.0.0.1"),
     };
 
-    Ipv4Address dst = Ipv4Address("0.0.0.1");
+    Ipv4Address dst("0.0.0.1");
     dsr::DsrRouteCacheEntry entry(ip, dst, Seconds(1));
     NS_TEST_EXPECT_MSG_EQ(entry.GetVector().size(), 2, "trivial");
     NS_TEST_EXPECT_MSG_EQ(entry.GetDestination(), Ipv4Address("0.0.0.1"), "trivial");
@@ -464,7 +464,7 @@
         Ipv4Address("1.1.1.1"),
     };
 
-    Ipv4Address dst2 = Ipv4Address("1.1.1.1");
+    Ipv4Address dst2("1.1.1.1");
     dsr::DsrRouteCacheEntry entry2(ip2, dst2, Seconds(2));
     dsr::DsrRouteCacheEntry newEntry;
     NS_TEST_EXPECT_MSG_EQ(rcache->AddRoute(entry2), true, "trivial");
@@ -516,7 +516,7 @@
     NS_TEST_EXPECT_MSG_EQ(q.GetSendBufferTimeout(), Seconds(10), "trivial");
 
     Ptr<const Packet> packet = Create<Packet>();
-    Ipv4Address dst1 = Ipv4Address("0.0.0.1");
+    Ipv4Address dst1("0.0.0.1");
     dsr::DsrSendBuffEntry e1(packet, dst1, Seconds(1));
     q.Enqueue(e1);
     q.Enqueue(e1);
@@ -528,7 +528,7 @@
     NS_TEST_EXPECT_MSG_EQ(q.Find(Ipv4Address("0.0.0.1")), false, "trivial");
     NS_TEST_EXPECT_MSG_EQ(q.GetSize(), 0, "trivial");
 
-    Ipv4Address dst2 = Ipv4Address("0.0.0.2");
+    Ipv4Address dst2("0.0.0.2");
     dsr::DsrSendBuffEntry e2(packet, dst2, Seconds(1));
     q.Enqueue(e1);
     q.Enqueue(e2);
@@ -541,7 +541,7 @@
     q.Enqueue(e3);
     NS_TEST_EXPECT_MSG_EQ(q.GetSize(), 2, "trivial");
     Ptr<Packet> packet4 = Create<Packet>();
-    Ipv4Address dst4 = Ipv4Address("0.0.0.4");
+    Ipv4Address dst4("0.0.0.4");
     dsr::DsrSendBuffEntry e4(packet4, dst4, Seconds(20));
     q.Enqueue(e4);
     NS_TEST_EXPECT_MSG_EQ(q.GetSize(), 3, "trivial");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/CMakeLists.txt ns-3.40/src/energy/CMakeLists.txt
--- ns-3.39/src/energy/CMakeLists.txt	2023-07-05 14:23:47.785427300 -0700
+++ ns-3.40/src/energy/CMakeLists.txt	2023-09-27 13:30:37.642839000 -0700
@@ -7,6 +7,7 @@
     helper/energy-harvester-helper.cc
     helper/energy-model-helper.cc
     helper/energy-source-container.cc
+    helper/generic-battery-model-helper.cc
     helper/li-ion-energy-source-helper.cc
     helper/rv-battery-model-helper.cc
     model/basic-energy-harvester.cc
@@ -15,6 +16,7 @@
     model/device-energy-model.cc
     model/energy-harvester.cc
     model/energy-source.cc
+    model/generic-battery-model.cc
     model/li-ion-energy-source.cc
     model/rv-battery-model.cc
     model/simple-device-energy-model.cc
@@ -25,6 +27,7 @@
     helper/energy-harvester-helper.h
     helper/energy-model-helper.h
     helper/energy-source-container.h
+    helper/generic-battery-model-helper.h
     helper/li-ion-energy-source-helper.h
     helper/rv-battery-model-helper.h
     model/basic-energy-harvester.h
@@ -33,6 +36,7 @@
     model/device-energy-model.h
     model/energy-harvester.h
     model/energy-source.h
+    model/generic-battery-model.h
     model/li-ion-energy-source.h
     model/rv-battery-model.h
     model/simple-device-energy-model.h
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/examples/basic-energy-model-test.cc ns-3.40/src/energy/examples/basic-energy-model-test.cc
--- ns-3.39/src/energy/examples/basic-energy-model-test.cc	2023-07-05 14:23:47.785427300 -0700
+++ ns-3.40/src/energy/examples/basic-energy-model-test.cc	2023-09-27 13:30:37.642839000 -0700
@@ -91,35 +91,35 @@
     // run state switch tests
     if (StateSwitchTest(WifiPhyState::IDLE))
     {
-        return 1;
+        return true;
         std::cerr << "Problem with state switch test (WifiPhy idle)." << std::endl;
     }
     if (StateSwitchTest(WifiPhyState::CCA_BUSY))
     {
-        return 1;
+        return true;
         std::cerr << "Problem with state switch test (WifiPhy cca busy)." << std::endl;
     }
     if (StateSwitchTest(WifiPhyState::TX))
     {
-        return 1;
+        return true;
         std::cerr << "Problem with state switch test (WifiPhy tx)." << std::endl;
     }
     if (StateSwitchTest(WifiPhyState::RX))
     {
-        return 1;
+        return true;
         std::cerr << "Problem with state switch test (WifiPhy rx)." << std::endl;
     }
     if (StateSwitchTest(WifiPhyState::SWITCHING))
     {
-        return 1;
+        return true;
         std::cerr << "Problem with state switch test (WifiPhy switching)." << std::endl;
     }
     if (StateSwitchTest(WifiPhyState::SLEEP))
     {
-        return 1;
+        return true;
         std::cerr << "Problem with state switch test (WifiPhy sleep)." << std::endl;
     }
-    return 0;
+    return false;
 }
 
 bool
@@ -302,7 +302,7 @@
     /*
      * Run simulation with different simulation time and update interval.
      */
-    uint8_t ret = 0;
+    bool ret = false;
 
     for (double simTimeS = 0.0; simTimeS <= m_simTimeS; simTimeS += m_timeStepS)
     {
@@ -311,7 +311,7 @@
         {
             if (DepletionTestCase(simTimeS, updateIntervalS))
             {
-                ret = 1;
+                ret = true;
                 std::cerr << "Depletion test case problem." << std::endl;
             }
             // reset callback count
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/examples/CMakeLists.txt ns-3.40/src/energy/examples/CMakeLists.txt
--- ns-3.39/src/energy/examples/CMakeLists.txt	2023-07-05 14:23:47.785427300 -0700
+++ ns-3.40/src/energy/examples/CMakeLists.txt	2023-09-27 13:30:37.642839000 -0700
@@ -1,4 +1,23 @@
 build_lib_example(
+  NAME generic-battery-discharge-example
+  SOURCE_FILES generic-battery-discharge-example.cc
+  LIBRARIES_TO_LINK ${libcore}
+                    ${libenergy}
+)
+
+build_example(
+  NAME generic-battery-wifiradio-example
+  SOURCE_FILES generic-battery-wifiradio-example.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libconfig-store}
+    ${libenergy}
+    ${libinternet}
+    ${libmobility}
+    ${libwifi}
+)
+
+build_lib_example(
   NAME li-ion-energy-source-example
   SOURCE_FILES li-ion-energy-source-example.cc
   LIBRARIES_TO_LINK ${libcore}
